Subject: Re: [PATCH 1/3] mm: Move arch_do_swap_page() call to before swap_free()

From: Peter Collingbourne <[email-masked]>
Date: Mon, 15 May 2023 17:16:09 -0700

On Sat, May 13, 2023 at 05:29:53AM +0200, David Hildenbrand wrote:
> On 13.05.23 01:57, Peter Collingbourne wrote:
> > Commit c145e0b47c77 ("mm: streamline COW logic in do_swap_page()") moved
> > the call to swap_free() before the call to set_pte_at(), which meant that
> > the MTE tags could end up being freed before set_pte_at() had a chance
> > to restore them. One other possibility was to hook arch_do_swap_page(),
> > but this had a number of problems:
> > 
> > - The call to the hook was also after swap_free().
> > 
> > - The call to the hook was after the call to set_pte_at(), so there was a
> >    racy window where uninitialized metadata may be exposed to userspace.
> >    This likely also affects SPARC ADI, which implements this hook to
> >    restore tags.
> > 
> > - As a result of commit 1eba86c096e3 ("mm: change page type prior to
> >    adding page table entry"), we were also passing the new PTE as the
> >    oldpte argument, preventing the hook from knowing the swap index.
> > 
> > Fix all of these problems by moving the arch_do_swap_page() call before
> > the call to free_page(), and ensuring that we do not set orig_pte until
> > after the call.
> > 
> > Signed-off-by: Peter Collingbourne <[email-masked]>
> > Suggested-by: Catalin Marinas <[email-masked]>
> > Link: https://linux-review.googlesource.com/id/I6470efa669e8bd2f841049b8c61020c510678965
> > Cc: <[email-masked]> # 6.1
> > Fixes: ca827d55ebaa ("mm, swap: Add infrastructure for saving page metadata on swap")
> > Fixes: 1eba86c096e3 ("mm: change page type prior to adding page table entry")
> 
> I'm confused. You say c145e0b47c77 changed something (which was after above
> commits), indicate that it fixes two other commits, and indicate "6.1" as
> stable which does not apply to any of these commits.

Sorry, the situation is indeed a bit confusing.

- In order to make the arch_do_swap_page() hook suitable for fixing the
  bug introduced by c145e0b47c77, patch 1 addresses a number of issues,
  including fixing bugs introduced by ca827d55ebaa and 1eba86c096e3,
  but we haven't fixed the c145e0b47c77 bug yet, so there's no Fixes:
  tag for it yet.

- Patch 2, relying on the fixes in patch 1, makes MTE install an
  arch_do_swap_page() hook (indirectly, by making arch_swap_restore()
  also hook arch_do_swap_page()), thereby fixing the c145e0b47c77 bug.

- 6.1 is the first stable version in which all 3 commits in my Fixes: tags
  are present, so that is the version that I've indicated in my stable
  tag for this series. In theory patch 1 could be applied to older kernel
  versions, but it wouldn't fix any problems that we are facing with MTE
  (because it only fixes problems relating to the arch_do_swap_page()
  hook, which older kernel versions don't hook with MTE), and there are
  some merge conflicts if we go back further anyway. If the SPARC folks
  (the previous only user of this hook) want to fix these issues with ADI,
  they can propose their own backport.

> > @@ -3959,7 +3960,6 @@ vm_fault_t do_swap_page(struct vm_fault *vmf)
> >   	VM_BUG_ON(!folio_test_anon(folio) ||
> >   			(pte_write(pte) && !PageAnonExclusive(page)));
> >   	set_pte_at(vma->vm_mm, vmf->address, vmf->pte, pte);
> > -	arch_do_swap_page(vma->vm_mm, vma, vmf->address, pte, vmf->orig_pte);
> >   	folio_unlock(folio);
> >   	if (folio != swapcache && swapcache) {
> 
> 
> You are moving the folio_free_swap() call after the folio_ref_count(folio)
> == 1 check, which means that such (previously) swapped pages that are
> exclusive cannot be detected as exclusive.

Ack. I will fix this in v2.

Peter

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel